package
{
   import flash.net.FileReference;
   
   internal class FileItem
   {
      private static var file_id_sequence:Number = 0;
      
      public static var FILE_STATUS_QUEUED:int = -1;
      
      public static var FILE_STATUS_IN_PROGRESS:int = -2;
      
      public static var FILE_STATUS_ERROR:int = -3;
      
      public static var FILE_STATUS_SUCCESS:int = -4;
      
      public static var FILE_STATUS_CANCELLED:int = -5;
      
      public static var FILE_STATUS_NEW:int = -6;
      
      public var file_reference:FileReference;
      
      public var index:Number = -1;
      
      public var file_status:int = 0;
      
      public var id:String;
      
      private var js_object:Object;
      
      private var postObject:Object;
      
      public function FileItem(param1:FileReference, param2:String, param3:Number)
      {
         var file_reference:FileReference = param1;
         var control_id:String = param2;
         var index:Number = param3;
         index = -1;
         file_status = 0;
         super();
         this.postObject = {};
         this.file_reference = file_reference;
         this.id = control_id + "_" + FileItem.file_id_sequence++;
         this.file_status = FileItem.FILE_STATUS_NEW;
         this.index = index;
         this.js_object = {
            "id":this.id,
            "index":this.index,
            "post":this.GetPostObject()
         };
         try
         {
            this.js_object.name = this.file_reference.name;
            this.js_object.size = this.file_reference.size;
            this.js_object.type = this.file_reference.type;
            this.js_object.creationdate = this.file_reference.creationDate;
            this.js_object.modificationdate = this.file_reference.modificationDate;
         }
         catch(ex:Error)
         {
            this.file_status = FileItem.FILE_STATUS_ERROR;
         }
         this.js_object.filestatus = this.file_status;
      }
      
      public function RemoveParam(param1:String) : void
      {
         delete this.postObject[param1];
      }
      
      public function AddParam(param1:String, param2:String) : void
      {
         this.postObject[param1] = param2;
      }
      
      public function GetPostObject() : Object
      {
         return this.postObject;
      }
      
      public function ToJavaScriptObject() : Object
      {
         this.js_object.file_status = this.file_status;
         this.js_object.post = this.GetPostObject();
         return this.js_object;
      }
      
      public function toString() : String
      {
         return "FileItem - ID: " + this.id;
      }
   }
}

